Codeforces Problem 712C Memory and De-Evolution(贪心,逆推)

此文章可以使用目录功能哟↑(点击上方[+])

比赛链接→Codeforces Round #370 (Div. 2)

 Codeforces Problem 712C Memory and De-Evolution

Accept: 0    Submit: 0
Time Limit: 2 seconds    Memory Limit : 256 megabytes

 Problem Description

Memory is now interested in the de-evolution of objects, specifically triangles. He starts with an equilateral triangle of side length x, and he wishes to perform operations to obtain an equilateral triangle of side length y.

In a single second, he can modify the length of a single side of the current triangle such that it remains a non-degenerate triangle (triangle of positive area). At any moment of time, the length of each side should be integer.

What is the minimum number of seconds required for Memory to obtain the equilateral triangle of side length y?

 Input

The first and only line contains two integers x and y (3 ≤ y < x ≤ 100 000) — the starting and ending equilateral triangle side lengths respectively.

 Output

Print a single integer — the minimum number of seconds required for Memory to obtain the equilateral triangle of side length y if he starts with the equilateral triangle of side length x.

 Sample Input

6 3
8 5
22 4

 Sample Output

4
3
6

 Hint

In the first sample test, Memory starts with an equilateral triangle of side length 6 and wants one of side length 3. Denote a triangle with sides a, b, and c as (a, b, c). Then, Memory can do (6,6,6)→(6,6,3)→(6,4,3)→(3,4,3)→(3,3,3).

In the second sample test, Memory can do (8,8,8)→(8,8,5)→(8,5,5)→(5,5,5).

In the third sample test, Memory can do: (22,22,22)→(7,22,22)→(7,22,16)→(7,10,16)→(7,10,4)→(7,4,4)→(4,4,4).

 Problem Idea

解题思路:

【题意】
现有边长为x的等边三角形,Memory想要将其变成边长为y的等边三角形

现规定Memory每秒能够改变一条边的大小,但要保证改变后的三条边仍能构成一个三角形

问,最少需要多少时间才能变为边长为y的等边三角形

【类型】
贪心,逆推

【分析】

一开始,正常人的想法就是如何改变边长为x的等边三角形的边,使得其变为边长为y的等边三角形

但是在不断尝试过程中,就会发现,貌似不是非常好处理

根据定理"三角形两边之和大于第三边,两边之差小于第三边"

就很难确定最初应该把x减少为多少合适,如果减少太多,势必会使得另外两条边减少速度过慢

(22,22,22)→(4,22,22)→(4,19,22)→(4,19,16)→(4,13,16)→(4,13,10)→(4,7,10)→(4,7,4)→(4,4,4)

但如果减少太少,同样会影响速率

应该是个怎么样的度,总是把握不好

这时,把问题反过来想想,发现有出路

减法控制不好,相对来说加法就简单得多

为了尽快使y->x,那每秒都要使得y增加得尽可能多

所以每次选取最短边,将其变为另两条边之和-1("三角形两边之和大于第三边")

直到三条边都大于等于x为止

【时间复杂度&&优化】
O(n)

题目链接→Codeforces Problem 712C Memory and De-Evolution

 Source Code

/*Sherlock and Watson and Adler*/
#pragma comment(linker, "/STACK:1024000000,1024000000")
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<queue>
#include<stack>
#include<math.h>
#include<vector>
#include<map>
#include<set>
#include<bitset>
#include<cmath>
#include<complex>
#include<string>
#include<algorithm>
#include<iostream>
#define eps 1e-9
#define LL long long
#define PI acos(-1.0)
#define bitnum(a) __builtin_popcount(a)
using namespace std;
const int N = 3;
const int M = 20005;
const int inf = 1000000007;
const int mod = 7;
int s[N];
int main()
{
    int x,y,i;
    scanf("%d%d",&x,&y);
    s[0]=s[1]=s[2]=y;
    for(i=0;s[0]<x||s[1]<x||s[2]<x;i++)
        s[i%3]=s[(i+1)%3]+s[(i+2)%3]-1;
    printf("%d\n",i);
    return 0;
}
菜鸟成长记

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值